/*	This script created by Christopher Bradford, Alive! Online Design.
    You may distribute it freely, but please keep the headers intact.

Lets you replace special characters in selected text 
or throughout the whole document.
*/

// MessageBox constants
var hsYesNoCancel = 3;
var hsQuestion = 32;
var hsOK = 0;
var hsInfo = 64;

// MessageBox button value constants
var hsYes = 6;
var hsNo = 7;
var hsCancel = 2;

// Initialize
var app = Application;
var active = app.ActiveDocument;
var strOldText = "";
var strNewText = "";

// Entities
var strEnts = 'AElig Aacute Acirc Agrave Aring Atilde Auml Ccedil ETH Eacute Ecirc Egrave Euml Iacute Icirc Igrave Iuml Ntilde Oacute Ocirc Ograve Oslash Otilde Ouml Uacute Ucirc Ugrave Uuml Yacute aacute acirc aelig agrave aring atilde auml ccedil eacute ecirc egrave eth euml iacute icirc igrave iuml ntilde oacute ocirc ograve oslash otilde ouml szlig thorn uacute ucirc ugrave uuml yacute yuml copy para pound reg sup1 sup2 sup3';

// Characters
var strChars = '                                                                   ';

// Set up arrays
var arrEnts = strEnts.split(" ");
var arrChars = strChars.split(" ");

function Main() {

	if (app.ActiveDocument.SelLength > 0) {
    
            // figure out the scope of the search
		var intUseSelText = app.MessageBox("Restrict replace to selected text?","Replace Special Characters",hsYesNoCancel + hsQuestion);

		if (intUseSelText == hsYes) { strOldText = app.ActiveDocument.SelText; }         // use selected text
		else if (intUseSelText == hsNo) {strOldText = app.ActiveDocument.Text; }        // use whole document
		else { strOldText = ""; }  // they cancelled the operation

	}

	else { strOldText = app.ActiveDocument.Text; }

if (strOldText != "") {	// if this is empty, it means they cancelled; skip to the end


	// Figure out if we're replacing characters or entities
	var resp = app.MessageBox("Replace entities (Yes to get characters, No to get entities)?", "Characters or Entities?", hsYesNoCancel + hsQuestion);

	if (resp != hsCancel) {	// don't do anything; skip to the end

		for (var counter = 0; counter < arrEnts.length; counter++) { // check each special character and entity

			if (resp == hsYes) {

				var strToFind = "&" + arrEnts[counter] + ';';
				var strReplacement = arrChars[counter];
			}

			else {

				var strToFind = arrChars[counter];
				var strReplacement = "&" + arrEnts[counter] + ';';
			
			}
				eval ("var reToFind = /" + strToFind + "/g");
				strNewText = strOldText.replace(reToFind, strReplacement);
        	    strOldText = strNewText;

		}	// end looping through arrays

eval ("app.ActiveDocument." + ((intUseSelText == hsYes) ? "SelText" : "Text") + " = strNewText;");    // replace the right text (selected text or full text)

	}	// end if replace was cancelled

}	// end if strOldText != ""

}	// end Main